#!/usr/bin/perl
#Data.pm
#The Data class represents a list of values, and an iterator.
#Written by Paul Stothard.

package ARFF::Data;

use strict;
use warnings;

sub new {
    my $object = shift;
    my $class  = ref($object) || $object;
    my $self   = {
        values   => [],
        iterator => 0
    };
    bless( $self, $class );
    return $self;
}

sub setTitle {
    my $self = shift;
    my $title;
    $title = shift if (@_);
    $self->{title} = $title;
}

sub getTitle {
    my $self = shift;
    return $self->{title};
}

sub addValue {
    my $self = shift;
    my $value;
    if (@_) {
        $value = shift;
    }
    else {
        return 0;
    }
    my $arrayReference = $self->{values};
    push( @$arrayReference, $value );
}

sub resetIterator {
    my $self = shift;
    $self->{iterator} = 0;
}

sub hasNext {
    my $self           = shift;
    my $arrayReference = $self->{values};
    if ( $self->{iterator} < scalar(@$arrayReference) ) {
        return 1;
    }
    else {
        return 0;
    }
}

sub getNextValue {
    my $self           = shift;
    my $arrayReference = $self->{values};
    my $iterator       = $self->{iterator};
    if ( $iterator < $self->getNumberOfValues() ) {
        $self->advanceIterator();
        return $arrayReference->[$iterator];
    }
    else {
        return 0;
    }
}

sub getNumberOfValues {
    my $self           = shift;
    my $arrayReference = $self->{values};
    return scalar(@$arrayReference);
}

sub write {
    my $self           = shift;
    my $arrayReference = $self->{values};
    print join( ", ", @$arrayReference ) . "\n";
}

sub toString {
    my $self           = shift;
    my $arrayReference = $self->{values};
    return join( ", ", @$arrayReference ) . "\n";
}

return 1;
